# Custom Properties

Custom properties allow you to add custom fields to resources in your workspace. Learn more about custom properties [here](https://docs.secoda.com/resource-and-metadata-management/adding-custom-properties).

## List Custom Properties

> Get all custom properties in the workspace.

```json
{"openapi":"3.0.0","info":{"title":"Secoda API","version":"8.22.39"},"tags":[{"name":"Custom Properties","description":"Custom properties allow you to add custom fields to resources in your workspace. Learn more about custom properties [here](https://docs.secoda.com/resource-and-metadata-management/adding-custom-properties).\n"}],"servers":[{"url":"https://api.secoda.co","description":"Base URL for all US cloud based workspaces"},{"url":"https://eapi.secoda.co","description":"Base URL for all EU cloud based workspaces"},{"url":"https://aapi.secoda.co","description":"Base URL for all APAC cloud based workspaces"},{"url":"https://{customer_domain}.secoda.co","description":"Base URL for On Premise Secoda workspaces","variables":{"customer_domain":{"default":"customer_domain","description":"The specific domain set up for your On Premise Secoda workspace."}}}],"security":[{"ApiKeyAuth":[]}],"paths":{"/api/v1/resource/all_v2/custom_properties/":{"get":{"operationId":"list_custom_properties","summary":"List Custom Properties","parameters":[],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"items":{"$ref":"#/components/schemas/v1_CustomPropertyOut"},"title":"Response","type":"array"}}}}},"description":"Get all custom properties in the workspace.","tags":["Custom Properties"]}}},"components":{"schemas":{"v1_CustomPropertyOut":{"properties":{"id":{"format":"uuid","title":"Id","type":"string"},"name":{"title":"Name","type":"string"},"entity_types":{"default":[],"items":{"type":"string"},"title":"Entity Types","type":"array"},"value_type":{"title":"Value Type","type":"string"},"integration":{"anyOf":[{"$ref":"#/components/schemas/v1_LiteIntegrationOut"},{"type":"null"}]}},"required":["id","name","value_type"],"title":"CustomPropertyOut","type":"object"},"v1_LiteIntegrationOut":{"properties":{"name":{"title":"Name","type":"string"},"type":{"title":"Type","type":"string"},"id":{"format":"uuid","title":"Id","type":"string"}},"required":["name","type"],"title":"LiteIntegrationOut","type":"object"}}}}
```

## Create Custom Property

> Create a new custom property in the workspace.

```json
{"openapi":"3.0.0","info":{"title":"Secoda API","version":"8.22.39"},"tags":[{"name":"Custom Properties","description":"Custom properties allow you to add custom fields to resources in your workspace. Learn more about custom properties [here](https://docs.secoda.com/resource-and-metadata-management/adding-custom-properties).\n"}],"servers":[{"url":"https://api.secoda.co","description":"Base URL for all US cloud based workspaces"},{"url":"https://eapi.secoda.co","description":"Base URL for all EU cloud based workspaces"},{"url":"https://aapi.secoda.co","description":"Base URL for all APAC cloud based workspaces"},{"url":"https://{customer_domain}.secoda.co","description":"Base URL for On Premise Secoda workspaces","variables":{"customer_domain":{"default":"customer_domain","description":"The specific domain set up for your On Premise Secoda workspace."}}}],"security":[{"ApiKeyAuth":[]}],"paths":{"/api/v1/resource/all_v2/custom_properties/":{"post":{"operationId":"create_custom_property","summary":"Create Custom Property","parameters":[],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/v1_CustomPropertyOut"}}}}},"description":"Create a new custom property in the workspace.","tags":["Custom Properties"],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/v1_CustomPropertyIn"}}},"required":true}}}},"components":{"schemas":{"v1_CustomPropertyOut":{"properties":{"id":{"format":"uuid","title":"Id","type":"string"},"name":{"title":"Name","type":"string"},"entity_types":{"default":[],"items":{"type":"string"},"title":"Entity Types","type":"array"},"value_type":{"title":"Value Type","type":"string"},"integration":{"anyOf":[{"$ref":"#/components/schemas/v1_LiteIntegrationOut"},{"type":"null"}]}},"required":["id","name","value_type"],"title":"CustomPropertyOut","type":"object"},"v1_LiteIntegrationOut":{"properties":{"name":{"title":"Name","type":"string"},"type":{"title":"Type","type":"string"},"id":{"format":"uuid","title":"Id","type":"string"}},"required":["name","type"],"title":"LiteIntegrationOut","type":"object"},"v1_CustomPropertyIn":{"properties":{"name":{"title":"Name","type":"string"},"entity_types":{"default":[],"items":{"type":"string"},"title":"Entity Types","type":"array"},"value_type":{"title":"Value Type","type":"string"}},"required":["name","value_type"],"title":"CustomPropertyIn","type":"object"}}}}
```

## Get Custom Property

> Get details of a specific custom property.

```json
{"openapi":"3.0.0","info":{"title":"Secoda API","version":"8.22.39"},"tags":[{"name":"Custom Properties","description":"Custom properties allow you to add custom fields to resources in your workspace. Learn more about custom properties [here](https://docs.secoda.com/resource-and-metadata-management/adding-custom-properties).\n"}],"servers":[{"url":"https://api.secoda.co","description":"Base URL for all US cloud based workspaces"},{"url":"https://eapi.secoda.co","description":"Base URL for all EU cloud based workspaces"},{"url":"https://aapi.secoda.co","description":"Base URL for all APAC cloud based workspaces"},{"url":"https://{customer_domain}.secoda.co","description":"Base URL for On Premise Secoda workspaces","variables":{"customer_domain":{"default":"customer_domain","description":"The specific domain set up for your On Premise Secoda workspace."}}}],"security":[{"ApiKeyAuth":[]}],"paths":{"/api/v1/resource/all_v2/custom_properties/{custom_property_id}/":{"get":{"operationId":"get_custom_property","summary":"Get Custom Property","parameters":[{"in":"path","name":"custom_property_id","schema":{"title":"Custom Property Id","type":"string"},"required":true}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/v1_CustomPropertyOut"}}}}},"description":"Get details of a specific custom property.","tags":["Custom Properties"]}}},"components":{"schemas":{"v1_CustomPropertyOut":{"properties":{"id":{"format":"uuid","title":"Id","type":"string"},"name":{"title":"Name","type":"string"},"entity_types":{"default":[],"items":{"type":"string"},"title":"Entity Types","type":"array"},"value_type":{"title":"Value Type","type":"string"},"integration":{"anyOf":[{"$ref":"#/components/schemas/v1_LiteIntegrationOut"},{"type":"null"}]}},"required":["id","name","value_type"],"title":"CustomPropertyOut","type":"object"},"v1_LiteIntegrationOut":{"properties":{"name":{"title":"Name","type":"string"},"type":{"title":"Type","type":"string"},"id":{"format":"uuid","title":"Id","type":"string"}},"required":["name","type"],"title":"LiteIntegrationOut","type":"object"}}}}
```

## Update Custom Property

> Update an existing custom property.

```json
{"openapi":"3.0.0","info":{"title":"Secoda API","version":"8.22.39"},"tags":[{"name":"Custom Properties","description":"Custom properties allow you to add custom fields to resources in your workspace. Learn more about custom properties [here](https://docs.secoda.com/resource-and-metadata-management/adding-custom-properties).\n"}],"servers":[{"url":"https://api.secoda.co","description":"Base URL for all US cloud based workspaces"},{"url":"https://eapi.secoda.co","description":"Base URL for all EU cloud based workspaces"},{"url":"https://aapi.secoda.co","description":"Base URL for all APAC cloud based workspaces"},{"url":"https://{customer_domain}.secoda.co","description":"Base URL for On Premise Secoda workspaces","variables":{"customer_domain":{"default":"customer_domain","description":"The specific domain set up for your On Premise Secoda workspace."}}}],"security":[{"ApiKeyAuth":[]}],"paths":{"/api/v1/resource/all_v2/custom_properties/{custom_property_id}/":{"put":{"operationId":"update_custom_property","summary":"Update Custom Property","parameters":[{"in":"path","name":"custom_property_id","schema":{"title":"Custom Property Id","type":"string"},"required":true}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/v1_CustomPropertyOut"}}}}},"description":"Update an existing custom property.","tags":["Custom Properties"],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/v1_CustomPropertyIn"}}},"required":true}}}},"components":{"schemas":{"v1_CustomPropertyOut":{"properties":{"id":{"format":"uuid","title":"Id","type":"string"},"name":{"title":"Name","type":"string"},"entity_types":{"default":[],"items":{"type":"string"},"title":"Entity Types","type":"array"},"value_type":{"title":"Value Type","type":"string"},"integration":{"anyOf":[{"$ref":"#/components/schemas/v1_LiteIntegrationOut"},{"type":"null"}]}},"required":["id","name","value_type"],"title":"CustomPropertyOut","type":"object"},"v1_LiteIntegrationOut":{"properties":{"name":{"title":"Name","type":"string"},"type":{"title":"Type","type":"string"},"id":{"format":"uuid","title":"Id","type":"string"}},"required":["name","type"],"title":"LiteIntegrationOut","type":"object"},"v1_CustomPropertyIn":{"properties":{"name":{"title":"Name","type":"string"},"entity_types":{"default":[],"items":{"type":"string"},"title":"Entity Types","type":"array"},"value_type":{"title":"Value Type","type":"string"}},"required":["name","value_type"],"title":"CustomPropertyIn","type":"object"}}}}
```

## Delete Custom Property

> Delete a custom property.

```json
{"openapi":"3.0.0","info":{"title":"Secoda API","version":"8.22.39"},"tags":[{"name":"Custom Properties","description":"Custom properties allow you to add custom fields to resources in your workspace. Learn more about custom properties [here](https://docs.secoda.com/resource-and-metadata-management/adding-custom-properties).\n"}],"servers":[{"url":"https://api.secoda.co","description":"Base URL for all US cloud based workspaces"},{"url":"https://eapi.secoda.co","description":"Base URL for all EU cloud based workspaces"},{"url":"https://aapi.secoda.co","description":"Base URL for all APAC cloud based workspaces"},{"url":"https://{customer_domain}.secoda.co","description":"Base URL for On Premise Secoda workspaces","variables":{"customer_domain":{"default":"customer_domain","description":"The specific domain set up for your On Premise Secoda workspace."}}}],"security":[{"ApiKeyAuth":[]}],"paths":{"/api/v1/resource/all_v2/custom_properties/{custom_property_id}/":{"delete":{"operationId":"delete_custom_property","summary":"Delete Custom Property","parameters":[{"in":"path","name":"custom_property_id","schema":{"title":"Custom Property Id","type":"string"},"required":true}],"responses":{"204":{"description":"No Content"}},"description":"Delete a custom property.","tags":["Custom Properties"]}}}}
```

## Update Entity Custom Property Value

> Update the value of a custom property for a specific entity.

```json
{"openapi":"3.0.0","info":{"title":"Secoda API","version":"8.22.39"},"tags":[{"name":"Custom Properties","description":"Custom properties allow you to add custom fields to resources in your workspace. Learn more about custom properties [here](https://docs.secoda.com/resource-and-metadata-management/adding-custom-properties).\n"}],"servers":[{"url":"https://api.secoda.co","description":"Base URL for all US cloud based workspaces"},{"url":"https://eapi.secoda.co","description":"Base URL for all EU cloud based workspaces"},{"url":"https://aapi.secoda.co","description":"Base URL for all APAC cloud based workspaces"},{"url":"https://{customer_domain}.secoda.co","description":"Base URL for On Premise Secoda workspaces","variables":{"customer_domain":{"default":"customer_domain","description":"The specific domain set up for your On Premise Secoda workspace."}}}],"security":[{"ApiKeyAuth":[]}],"paths":{"/api/v1/resource/all_v2/custom_properties/{custom_property_id}/{entity_id}/":{"put":{"operationId":"update_entity_custom_property","summary":"Update Entity Custom Property Value","parameters":[{"in":"path","name":"custom_property_id","schema":{"title":"Custom Property Id","type":"string"},"required":true},{"in":"path","name":"entity_id","schema":{"title":"Entity Id","type":"string"},"required":true}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/v1_EntityWithCustomPropertyOut"}}}}},"description":"Update the value of a custom property for a specific entity.","tags":["Custom Properties"],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/v1_CustomPropertyValueIn"}}},"required":true}}}},"components":{"schemas":{"v1_EntityWithCustomPropertyOut":{"properties":{"id":{"format":"uuid","title":"Id","type":"string"},"properties2":{"additionalProperties":{"type":"string"},"title":"Properties2","type":"object"}},"required":["id","properties2"],"title":"EntityWithCustomPropertyOut","type":"object"},"v1_CustomPropertyValueIn":{"properties":{"value":{"title":"Value","type":"string"}},"required":["value"],"title":"CustomPropertyValueIn","type":"object"}}}}
```

## Bulk Update Entity Custom Properties

> Update custom property values for multiple entities in a single request.\
> To bulk delete custom property values, set their values to an empty string ("").<br>

```json
{"openapi":"3.0.0","info":{"title":"Secoda API","version":"8.22.39"},"tags":[{"name":"Custom Properties","description":"Custom properties allow you to add custom fields to resources in your workspace. Learn more about custom properties [here](https://docs.secoda.com/resource-and-metadata-management/adding-custom-properties).\n"}],"servers":[{"url":"https://api.secoda.co","description":"Base URL for all US cloud based workspaces"},{"url":"https://eapi.secoda.co","description":"Base URL for all EU cloud based workspaces"},{"url":"https://aapi.secoda.co","description":"Base URL for all APAC cloud based workspaces"},{"url":"https://{customer_domain}.secoda.co","description":"Base URL for On Premise Secoda workspaces","variables":{"customer_domain":{"default":"customer_domain","description":"The specific domain set up for your On Premise Secoda workspace."}}}],"security":[{"ApiKeyAuth":[]}],"paths":{"/api/v1/resource/all_v2/bulk_update/custom_properties/":{"put":{"operationId":"bulk_update_entity_custom_properties","summary":"Bulk Update Entity Custom Properties","parameters":[],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/v1_CustomPropertyBulkUpdateOut"}}}}},"description":"Update custom property values for multiple entities in a single request.\nTo bulk delete custom property values, set their values to an empty string (\"\").\n","tags":["Custom Properties"],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/v1_CustomPropertyBulkUpdateIn"}}},"required":true}}}},"components":{"schemas":{"v1_CustomPropertyBulkUpdateOut":{"properties":{"entities":{"items":{"$ref":"#/components/schemas/v1_EntityWithCustomPropertyOut"},"title":"Entities","type":"array"}},"required":["entities"],"title":"CustomPropertyBulkUpdateOut","type":"object"},"v1_EntityWithCustomPropertyOut":{"properties":{"id":{"format":"uuid","title":"Id","type":"string"},"properties2":{"additionalProperties":{"type":"string"},"title":"Properties2","type":"object"}},"required":["id","properties2"],"title":"EntityWithCustomPropertyOut","type":"object"},"v1_CustomPropertyBulkUpdateIn":{"properties":{"entity_ids":{"items":{"type":"string"},"title":"Entity Ids","type":"array"},"properties":{"type":"object","additionalProperties":{"type":"string"},"title":"Properties"}},"required":["entity_ids","properties"],"title":"CustomPropertyBulkUpdateIn","type":"object"}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.secoda.co/api/reference/custom-properties.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
